require 'savon'
require 'json'

module Lpaisais
  module API
    class Client
      class << self
        def call(update = nil, data = {})
          fail InvalidConfiguration if Lpaisais::API.config[:wsdl].blank?
          fail InvalidConfiguration if Lpaisais::API.config[:key].blank?
          fail InvalidConfiguration if Lpaisais::API.config[:timeout].blank?
          client = Savon.client do
            wsdl Lpaisais::API.config[:wsdl]
            open_timeout Lpaisais::API.config[:timeout].to_i
            read_timeout Lpaisais::API.config[:timeout].to_i
          end
          body = { params: build_params(update, data) }
          response = client.call(:lpaisais, message: body)
          parse_response(response.body[:lpaisais_response][:return])
        end

        private

        def build_params(update, data)
          {
            call: update,
            type: :home,
            data: data,
            key: Lpaisais::API.config[:key]
          }.to_json
        end

        def parse_response(response)
          JSON.parse(response.gsub("'", '"'))
        end
      end
    end
  end
end
